#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       Strip
#       
#       Copyright 2011 Kekun <kekun.plazas@laposte.net>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.



# #      TO DO
#
#       Implémenter le mode "zoom selon la largeur"
#       Add lens
#       Add bookmarks
#       Add image improvement
#       Add document properties and informations
#       Add preferences
#       Add a database to remember informations on books (last page used, manga mode...)
#       Choix de l'algo de redimensionnement
##      Pour v0.1
#       Préparer l'installation
#       Redessiner après la fermeture de la fenêtre de préférences

import os
import pygtk
pygtk.require("2.0")
import gtk

#~ try:
import modebutton
import book
import image
import preferences

class UI(object):
    def __init__(self):
        self.install_dir = '/usr/share/pyshared/strip/src/'
        
        # Set preferences
        self.preferences = preferences.Preferences()
        
        self.call_main_window()
                
        self.mainWindow_size = self.get_layout_size()
        self.layout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(4095, 4095, 4095))
        
        self.book = book.Book('', self.preferences.imageTypes, self.preferences.archiveTypes)
        self.actual_page = 0
        self.draw_pages()
    
    def call_main_window(self):
        # Import the UI
        window = gtk.Builder()
        try:
            window.add_from_file('ui/strip.glade')
        except:
            window.add_from_file(self.install_dir + 'ui/strip.glade')
        self.mainWindow = window.get_object('mainWindow')
        self.toolbars = window.get_object('toolbars')
        self.modeToolbar = window.get_object('modeToolbar')
        self.pagechangerToolbar = window.get_object('pagechangerToolbar')
        self.appToolbar = window.get_object('appToolbar')
        
        self.preferencesWindow = window.get_object('preferencesWindow')
        self.aboutWindow = window.get_object('aboutWindow')
        self.filechooserWindow = window.get_object('filechooserWindow')
        self.filter = window.get_object('filter')
        self.filter.set_name("Images")
        for type in self.preferences.imageTypes:
            self.filter.add_pattern("*." + type)
        for type in self.preferences.archiveTypes:
            self.filter.add_pattern("*." + type)
        #~ self.filter.add_mime_type("image/png")
        #~ self.filter.add_mime_type("image/jpeg")
        #~ self.filter.add_mime_type("image/gif")
        #~ self.filter.add_pattern("*.*")
        
        # Import tools
        self.mangaMode = window.get_object('mangaMode')
        if self.preferences.mangaMode:
            self.mangaMode.set_active(True)
        self.doubleMode = window.get_object('doubleMode')
        if self.preferences.doubleMode:
            self.doubleMode.set_active(True)
        self.zoomMode = window.get_object('zoomMode')
        if self.preferences.zoomMode:
            self.zoomMode.set_active(True)
        self.pageLeftLabel = window.get_object('pageLeftLabel')
        self.pageMiddleLabel = window.get_object('pageMiddleLabel')
        self.pageRightLabel = window.get_object('pageRightLabel')
        self.pageAdjustment = window.get_object('pageAdjustment')
        self.pageScroolbar = window.get_object('pageScroolbar')
        self.lensButton = window.get_object('lensButton')
        self.bookmarkButton = window.get_object('bookmarkButton')
        self.menuButton = window.get_object('menuButton')
        
        # Import menu
        self.menu = window.get_object('menu')
        self.shadow_check = window.get_object('shadow_check')
        self.shadow_check.set_active(self.preferences.shadow)
        self.clockwise_check = window.get_object('clockwise_check')
        self.clockwise_check.set_active(self.preferences.clockwise)
        
        # Import layout and images
        self.layout = window.get_object('layout')
        self.imageLeft = window.get_object('imageLeft')
        self.imageRight = window.get_object('imageRight')
        self.shadowLeft = window.get_object('shadowLeft')
        self.shadowRight = window.get_object('shadowRight')
        
        self.hbox2 = window.get_object('hbox2')
                
        window.connect_signals(self)
        
        # Modebutton tests
        #~ self.a = modebutton.ModeButton()
        #~ self.a.show()
        #~ self.b = gtk.ToolItem()
        #~ self.b.show()
        #~ self.b.add(self.a)
        #~ self.modeToolbar.insert(self.b, -1)
        #~ left = gtk.Label("Left")
        #~ self.a.append(left)
        #~ right = gtk.Label("Left")
        #~ self.a.append(right)
        
        # Hide not yet used elements
        self.zoomMode.set_sensitive(False)
        self.lensButton.set_sensitive(False)
        self.bookmarkButton.set_sensitive(False)
        
        properties = window.get_object('properties')
        comments = window.get_object('comments')
        enhance = window.get_object('enhance')
        preferences = window.get_object('preferences')
        properties.set_sensitive(False)
        comments.set_sensitive(False)
        enhance.set_sensitive(False)
        preferences.hide()
        
    #~ def call_preferences_window(self):
        #~ window = gtk.Builder()
        #~ try:
            #~ window.add_from_file('ui/preferences.glade')
        #~ except:
            #~ window.add_from_file(self.install_dir + 'ui/preferences.glade')
        #~ self.preferences_window = window.get_object('preferencesWindow')
        #~ self.preferences_window.set_transient_for(self.mainWindow)
        #~ self.preferences_window.show()
        #~ window.connect_signals(self)
        #~ 
        #~ self.check_shadow = window.get_object('check_shadow')
        #~ self.check_shadow.set_active(self.preferences.shadow)
        #~ self.check_clockwise = window.get_object('check_clockwise')
        #~ self.check_clockwise.set_active(self.preferences.clockwise)
        #~ self.check_manga_default = window.get_object('check_manga_default')
        #~ self.check_double_default = window.get_object('check_double_default')
        #~ self.check_zoom_default = window.get_object('check_zoom_default')
        #~ self.check_rotated_default = window.get_object('check_rotated_default')
        #~ 
        #~ # Hide not yet used elements
        #~ self.check_manga_default.hide()
        #~ self.check_double_default.hide()
        #~ self.check_zoom_default.hide()
        #~ self.check_rotated_default.hide()
    
    def on_preferencesWindow_destroy(self, widget):
        self.draw_pages()
    
    #### Toolbar
    def on_mangaMode_toggled(self, widget):
        '''Set the manga mode (reverse page display order and handeling)'''
        self.preferences.mangaMode = False
        if self.mangaMode.get_active():
            self.preferences.mangaMode = True
        self.pageScroolbar.set_inverted(self.preferences.mangaMode)
        self.draw_pages()
    
    def on_doubleMode_toggled(self, widget):
        self.preferences.doubleMode = False
        if self.doubleMode.get_active():
            self.preferences.doubleMode = True
        self.draw_pages()
    
    def on_zoomMode_toggled(self, widget):
        self.preferences.zoomMode = False
        if self.zoomMode.get_active():
            self.preferences.zoomMode = True
        self.draw_pages()
    
    def on_pageLeft_clicked(self, widget):
        '''Move to the next left pages of the book'''
        if self.preferences.mangaMode:
            self.pageNext()
        else:
            self.pagePrevious()
    
    def on_pageRight_clicked(self, widget):
        '''Move to the next right pages of the book'''
        if self.preferences.mangaMode:
            self.pagePrevious()
        else:
            self.pageNext()
    
    def on_pageAdjustment_value_changed(self, widget):
        '''Change the pages when the horizontal cursor is used'''
        # Redraw only on new integer values
        if int(self.pageAdjustment.get_value()) != self.actual_page:
            self.actual_page = int(self.pageAdjustment.get_value())
            self.draw_pages()
    
    def on_layout_button_press_event(self, widget, event):
        '''Change the pages depending of where the layout is clicked'''
        if event.button == 1:
            if not self.preferences.rotated:
                # Click on the left side
                if self.layout.get_pointer()[0] < int(self.get_layout_size()[0] / 2):
                     self.on_pageLeft_clicked(None)
                # Click on the right side
                else:
                    self.on_pageRight_clicked(None)
            if self.preferences.rotated:
                # Click on the top side
                if self.layout.get_pointer()[1] < int(self.get_layout_size()[1] / 2):
                    if self.preferences.clockwise:
                        self.on_pageLeft_clicked(None)
                    else:
                        self.on_pageRight_clicked(None)
                # Click on the bottom side      
                else:
                    if not self.preferences.clockwise:
                        self.on_pageLeft_clicked(None)
                    else:
                        self.on_pageRight_clicked(None)
        if event.button == 2:
            self.on_fullscreen_activate(None)
        if event.button == 3 and self.preferences.is_fullscreen:
            self.menu.popup(None, None, None, 1, gtk.get_current_event_time())
            self.menu.select_first(True)
    
    def on_lensButton_clicked(self, widget):
        print('lens')
    
    def on_bookmarkButton_clicked(self, widget):
        print('bookmark')
    
    def on_menuButton_clicked(self, widget):
        '''Display the app menu when the menu button is clicked'''
        if not self.menu.get_attach_widget():
            self.menu.attach_to_widget(widget, None)
        self.menu.popup(None, None, self.menu_position, 1, gtk.get_current_event_time())
        self.menu.select_first(True)
    
    def on_menu_deactivate(self, widget):
        '''Set the menu button back to normal when the menu is closed'''
        self.menuButton.set_active(False)
    
    #### Menu
    def on_open_activate(self, widget):
        '''Display the Open dialog to select a book to read'''
        self.filechooserWindow.run()
        self.filechooserWindow.hide()
        self.open_file(self.filechooserWindow.get_filename())
    
    def on_properties_activate(self, widget):
        print('properties')
    
    def on_comments_activate(self, widget):
        print('comments')
    
    def on_fullscreen_activate(self, widget):
        if self.preferences.is_fullscreen:
            self.preferences.is_fullscreen = False
            self.toolbars.show()
            self.mainWindow.unfullscreen()
        else:
            self.preferences.is_fullscreen = True
            self.toolbars.hide()
            self.mainWindow.fullscreen()
    
    def on_rotate_activate(self, widget):
        '''Rotate the pages on a choosen side or make them back to normal'''
        if self.preferences.rotated:
            self.preferences.rotated = False
        else:
            self.preferences.rotated = True
        self.draw_pages()
    
    def on_enhance_activate(self, widget):
        print('enhance')
    
    def on_about_activate(self, widget):
        '''Display the About dialog'''
        self.aboutWindow.run()
        self.aboutWindow.hide()
        
    def on_preferences_activate(self, widget):
        '''Display the preferences window'''
        self.call_preferences_window()
        
    def on_preferencesWindow_destroy(self, widget):
        self.draw_pages()
    
    def menu_position(self, menu, data=None):
        '''Return the position of the menu under the clicked widget'''
        widget = menu.get_attach_widget()
        allocation = widget.get_allocation()
        window_pos = widget.window.get_position()
        x = window_pos[0] + allocation.x
        y = window_pos[1] + allocation.y + allocation.height
        return (x, y, True)
    
    #### Preferences
    def on_shadow_check_toggled(self, widget):
        self.preferences.shadow = False
        if self.shadow_check.get_active():
            self.preferences.shadow = True
        self.draw_pages()
    
    def on_clockwise_check_toggled(self, widget):
        self.preferences.clockwise = False
        if self.clockwise_check.get_active():
            self.preferences.clockwise = True
        self.draw_pages()
    
    #### Other methods
    def on_open_button_clicked(self, widget):
        self.on_open_activate(None)
        
    def on_mainWindow_destroy(self, widget):
        self.quit()
                
    def open_file(self, path):
        '''Open the folder of the image or the archive given in path'''
        self.actual_page = 1
        self.book = book.Book(path, self.preferences.imageTypes, self.preferences.archiveTypes)
        self.pageAdjustment.set_lower(1)
        self.pageAdjustment.set_upper(self.book.length)
        self.draw_pages()
        
    def on_mainWindow_check_resize(self, widget):
        '''Redraw the pages if the size of the layout changed'''
        if self.mainWindow_size != self.get_layout_size():
            self.mainWindow_size = self.get_layout_size()
            self.draw_pages()
    
    def on_mainWindow_key_press_event(self, widget, event):
        key = gtk.gdk.keyval_name(event.keyval)
        if key == 'space':
            self.pageNext()
        if key == 'BackSpace':
            self.pagePrevious()
        if key == 'Home':
            self.pageAdjustment.set_value(self.pageAdjustment.get_lower())
        if key == 'End':
            self.pageAdjustment.set_value(self.pageAdjustment.get_upper())
        if key == 'Left':
            self.on_pageLeft_clicked(None)
        if key == 'Right':
            self.on_pageRight_clicked(None)
    
    def pageNext(self):
        '''Go forward in the book'''
        if self.preferences.doubleMode:
            self.actual_page = int(self.actual_page /2) * 2 + 2
        else:
            self.actual_page += 1
        self.check_page()
        self.draw_pages()
    
    def pagePrevious(self):
        '''Go backward in the book'''
        if self.preferences.doubleMode:
            self.actual_page = int(self.actual_page /2) * 2 - 2
        else:
            self.actual_page -= 1
        self.check_page()
        self.draw_pages()
    
    def get_layout_size(self):
        '''Get the size of the layout'''
        heigth, width = self.mainWindow.get_size()
        if not self.preferences.is_fullscreen:
            width -= self.appToolbar.size_request()[1]
        return heigth, width
    
    def check_page(self):
        if self.actual_page < self.pageAdjustment.get_lower():
            self.actual_page = self.pageAdjustment.get_lower()
        if self.actual_page > self.pageAdjustment.get_upper():
            self.actual_page = self.pageAdjustment.get_upper()
        if int(self.pageAdjustment.get_value()) != self.actual_page:
            self.pageAdjustment.set_value(self.actual_page)
    
    def draw_pages(self):
        '''Draw the pages in the layout'''
        try:
            if self.book.length > 0:
                self.layout.show()
                self.hbox2.hide()
            else:
                self.layout.hide()
                self.hbox2.show()
        except:
            self.layout.hide()
            self.hbox2.show()
        
        # Define the middle of the layout
        page_layout = int(self.get_layout_size()[0] / 2), self.get_layout_size()[1]
                
        if self.preferences.doubleMode:
            self.pageMiddleLabel.set_text('')
            if not self.preferences.mangaMode:
                if int(self.actual_page / 2) * 2 < 1:
                    self.hide_page(True)
                    self.pageLeftLabel.set_text('')
                else:
                    self.draw_page(True, self.book.page[int(self.actual_page / 2) * 2 - 1])
                    self.pageLeftLabel.set_text(str(int(self.actual_page / 2) * 2))
                if int(self.actual_page / 2) * 2 + 1 > self.book.length:
                    self.hide_page(False)
                    self.pageRightLabel.set_text('')
                else:
                    self.draw_page(False, self.book.page[int(self.actual_page / 2) * 2 - 0])
                    self.pageRightLabel.set_text(str(int(self.actual_page / 2) * 2 + 1))
            else:
                if int(self.actual_page / 2) * 2 - 1 < 0:
                    self.hide_page(False)
                    self.pageRightLabel.set_text('')
                else:
                    self.draw_page(False, self.book.page[int(self.actual_page / 2) * 2 - 1])
                    self.pageRightLabel.set_text(str(int(self.actual_page / 2) * 2 + 0))
                if int(self.actual_page / 2) * 2 + 1 > self.book.length:
                    self.hide_page(True)
                    self.pageLeftLabel.set_text('')
                else:
                    self.draw_page(True, self.book.page[int(self.actual_page / 2) * 2 - 0])
                    self.pageLeftLabel.set_text(str(int(self.actual_page / 2) * 2 + 1))
        else:
            self.pageLeftLabel.set_text('')
            self.pageRightLabel.set_text('')
            self.pageMiddleLabel.set_text(str(self.actual_page))
            self.hide_page(True)
            self.draw_page(False, self.book.page[self.actual_page - 1])
            self.pageLeftLabel.set_text('')
            self.pageRightLabel.set_text('')
            self.pageMiddleLabel.set_text(str(self.actual_page))
    
    def draw_page(self, is_left_page, page):
        # Show the images of the page
        if is_left_page:
            self.imageLeft.show()
            current_page = self.imageLeft
            if self.preferences.shadow:
                self.shadowLeft.show()
                current_shadow = self.shadowLeft
            else:
                self.shadowLeft.hide()
        else:
            self.imageRight.show()
            current_page = self.imageRight
            if self.preferences.shadow:
                self.shadowRight.show()
                current_shadow = self.shadowRight
            else:
                self.shadowRight.hide()
        
        # Open the images
        if self.preferences.shadow:
            try:
                shadow = book.Page(self.preferences.shadow_image_path)
            except:
                shadow = book.Page(self.install_dir + self.preferences.shadow_image_path)
        
        # Flip the shadow image if needed
        if (is_left_page and self.preferences.shadow) or (not self.preferences.doubleMode and (self.actual_page - (not self.preferences.mangaMode)) % 2):
            flip = True
        else:
            flip = False
        
        # Calculate the size available for the page and the ratios
        
        if self.preferences.rotated:
            page_layout = self.get_layout_size()[0], int(self.get_layout_size()[1] / (self.preferences.doubleMode + 1))
            page_ratio = float(page.size[1])/float(page.size[0])
        else:
            page_layout = int(self.get_layout_size()[0] / (self.preferences.doubleMode + 1)), self.get_layout_size()[1]
            page_ratio = float(page.size[0])/float(page.size[1])
        layout_ratio = float(page_layout[0])/float(page_layout[1])
                
        # If the space reserved to the page is taller than the page
        if layout_ratio < page_ratio:
            size = (page_layout[0], int(float(page_layout[0]) * (1 / page_ratio)))
        # If the space reserved to the page is wider than the page (or have the same proportions)
        else:
            size = (int(float(page_layout[1]) * page_ratio), page_layout[1])
        
        # Set the angle in degrees
        if self.preferences.rotated:
            if self.preferences.clockwise:
                rotation_angle = 270
            else:
                rotation_angle = 90
        else:
            rotation_angle = 0
        
        # Rotate, resize, convert, set and place images
        self.set_image(page.image, page_layout, is_left_page, current_page, size, rotation_angle)
        if self.preferences.shadow:
            self.set_image(shadow.image, page_layout, is_left_page, current_shadow, size, rotation_angle, flip)
            
    def hide_page(self, is_left_page):
        '''Hide the images if there is no page to display'''
        if is_left_page:
            self.imageLeft.hide()
            if self.preferences.shadow:
                self.shadowLeft.hide()
        else:
            self.imageRight.hide()
            if self.preferences.shadow:
                self.shadowRight.hide()
    
    def set_image(self, im, page_layout, is_left_page, destination, size = (0, 0), rotation_angle = 0, flip = False):
        '''Make a PIL image into a pixbuf, resize and rotate it, then return it into a GTK image and set its position.'''
        im = image.pil_to_pixbuf(im)
        im = image.resize_and_rotate(im, size, rotation_angle, flip)
        destination.set_from_pixbuf(im)
        self.move_page(page_layout, size, is_left_page, destination)
    
    def move_page(self, page_layout, size, is_left_page, image):
        '''Move the images to their correct position'''
        #~ self.get_layout_size()[0], int(self.get_layout_size()[1] / (self.preferences.doubleMode + 1))
        if not self.preferences.doubleMode:
            offset = (size[0] + self.get_layout_size()[0]) / 2
            self.layout.move(image, page_layout[0] - offset, (page_layout[1] - size[1]) / 2)
        else:
            offset = size[self.preferences.rotated] * is_left_page
            if not self.preferences.rotated:
                self.layout.move(image, page_layout[0] - offset, (page_layout[1] - size[1]) / 2)
            else:
                if self.preferences.clockwise:
                    self.layout.move(image, (page_layout[0] - size[0]) / 2, page_layout[1] - offset)
                else:
                    offset = size[self.preferences.rotated] * (not is_left_page)
                    self.layout.move(image, (page_layout[0] - size[0]) / 2, page_layout[1] - offset)
    
    def quit(self):
        '''Quit the application'''
        print('Bye')
        gtk.main_quit()

if __name__ == '__main__':
    ui = UI()
    gtk.main()
